/mob/living/simple_animal/hostile/endo/arcatgirl
	name = "catgirl"
	desc = "It's a catgirl, looking for someone to fill her womb."
	icon = 'icons/mob/endo.dmi'
	icon_state = "catgirl"
	icon_living = "catgirl"
	icon_dead = "catgirl-dead"
	icon_gib = "catgirl"
	baseicon = "catgirl"
	var/awakeIcon = "catgirl"
	var/asleepIcon = "catgirlasleep"
	speak_chance = 0
	turns_per_move = 3
	response_help = "pets"
	response_disarm = "gently pushes aside"
	response_harm = "pokes"
	speed = 8
	maxHealth = 100
	health = 100
	destroy_surroundings = 0

	harm_intent_damage = 0
	melee_damage_lower = 0
	melee_damage_upper = 0
	attacktext = "bapped"
	attack_sound = 'sound/weapons/throwtap.ogg'

	capacity = 1
	max_size = 1.5
	picky = 0

	//My catgirls can breathe in space!  For testing purposes.
	min_oxy = 0
	max_oxy = 0
	min_tox = 0
	max_tox = 0
	min_co2 = 0
	max_co2 = 0
	min_n2 = 0
	max_n2 = 0
	minbodytemp = 0

	break_stuff_probability = 0

	faction = "arcatgirl"
	
	var/wombfill = 0
	var/emptystepper = 0
	var/catnapstepper = 0
	var/catnap = 0

/mob/living/simple_animal/hostile/endo/arcatgirl/New()
	
	if(!vore_organs.len)
		var/datum/belly/B = new /datum/belly(src)
		B.immutable = 1
		B.name = "Womb"
		B.inside_flavor = "Tight, yet very comfortable and warm."
		B.digest_mode = "Hold" // Catgirl wombs shouldn't juice people.
		vore_organs[B.name] = B
		vore_selected = "Womb"
		B.vore_verb = "shove"
		B.vore_sound = "sound/vore/insertion3.ogg"
		B.escapable = 1  //Note to self, make it so you can only escape once she falls asleep.
		B.escapetime = 100 //Alternately, make it so escape is easier when she's asleep.
		B.emote_lists[DM_HOLD] = list(
			"The walls squeeze you gently for a moment.",
			"You can hear your captor purring.",
			"You feel the catgirl's paws rubbing over your form.",
			"It's so warm...",
			"It's so comfortable...")

		B.emote_lists[DM_DIGEST] = list(
			"Something's happening that shouldn't be happening!")  //Note to self, write struggle lines later.
	CatgirlRandomizer()
	..()
	
/mob/living/simple_animal/hostile/endo/arcatgirl/Life()  //Warning, terrible code ahead.

	..()

	wombfill = 0
	for(var/I in vore_organs)
		var/datum/belly/B = vore_organs[I]
		if(B.name == "Womb")
			for(var/mob/living/M in B.internal_contents)
				wombfill += M.size_multiplier
	if(wombfill >= capacity)
		hostile = 0
		emptystepper = 0
		
		if(catnapstepper <= 40)
			catnapstepper++
			stop_automated_movement = 0
		else
			if(!catnap)
				catnap = 1
				custom_emote(1,"falls asleep, cradling her pregnant belly.")
			stop_automated_movement = 1
		stop_automated_movement_when_pulled = 1
	else
		if(emptystepper <= 20)
			emptystepper++
			catnapstepper = 0
		else
			if(catnap || catnapstepper)
				catnapstepper = 0
				catnap = 0
				custom_emote(1,"wakes up!")
			if(!hostile)
				hostile = 1
				stop_automated_movement = 0
				custom_emote(1,"grows restless...")
			stop_automated_movement_when_pulled = 0

	for(var/I in vore_organs)  //This is just a personal preference bit.
		var/datum/belly/B = vore_organs[I]
		if(B.name == "Womb")
			if(B.digest_mode == "Digest")
				B.digest_mode = "Hold"  // CATGIRL WOMBS SHOULDN'T JUICE PEOPLE.  :P
				custom_emote(1,"shivers, having stopped something horrible from happening.")
				
	if(!ckey)  //If not a player, this next bit should make a catgirl's womb heal people if the catgirl's asleep and they need healing.
		var/healPlz = 0
		nutrition = 400  //Magical catgirl is always capable of healing!
		for(var/I in vore_organs)
			var/datum/belly/B = vore_organs[I]
			if(B.name == "Womb")
				for(var/mob/living/M in B.internal_contents)
					if(M.health < M.maxHealth)  //If the heal mode took care of wounds, I'd try to add a check for wounds.
						healPlz = 1
				if(healPlz == 1 && catnap == 1)
					B.digest_mode = "Heal"
				else
					B.digest_mode = "Hold"
	UpdateBaseIcon()
	update_icons()
	UpdateDesc()
	
/mob/living/simple_animal/hostile/endo/arcatgirl/Process_Spacemove(var/check_drift = 0)
	return 1	//My catgirls are SPACE catgirls!  For testing purposes.

/mob/living/simple_animal/hostile/endo/arcatgirl/FindTarget()
	. = ..()
	if(.)
		if(istype(., /mob/living/carbon/human))
			var/action = pick( list( "perks up her ears at [.]!", "stares alertly at [.].", "looks like she wants [.] inside her!", "decides [.] belongs inside her!") )
			if(action)
				custom_emote(1,action)

/mob/living/simple_animal/hostile/endo/arcatgirl/ListTargets(var/dist = 7)
	var/list/L = hearers(src, dist)

	for (var/atom/A in L)  //Catgirls only care about people they can shove in their womb!
		if(!istype(A, /mob/living/carbon/human))  //And they only shove people in their womb!
			L -= A  //I hope this works!

	return L

/mob/living/simple_animal/hostile/endo/arcatgirl/proc/UpdateDesc()
	if(wombfill >= capacity)
		if(!catnap)
			desc = "It's a catgirl, purring and blushing as she rubs her paws over a large, pregnant belly."
		else
			desc = "It's a catgirl, fast asleep and cradling her large, pregnant belly."
	else
		if(catnap)
			desc = "It's a catgirl, and she's fast asleep."
		else
			if(emptystepper <= 20 && !hostile)
				desc = "It's a catgirl."
			else
				desc = "It's a catgirl, and she looks restless..."
				
/mob/living/simple_animal/hostile/endo/arcatgirl/proc/UpdateBaseIcon()  //Silly story behind this.  //Which I've forgotten.
	if(catnap)
		baseicon = asleepIcon
	else
		baseicon = awakeIcon

/mob/living/simple_animal/hostile/endo/arcatgirl/animal_nom(var/mob/living/T in oview(1))

	Move(T.loc) //Makes the catgirl actually move over the person they're trying to shove into their womb.
	..()

/mob/living/simple_animal/hostile/endo/arcatgirl/proc/CatgirlRandomizer()  //Will have to figure out way to make it so new catgirl types don't have to overwrite this...
	var/picker = rand(0,3)
	switch(picker)
		if(0)
			icon_state = "catgirl"
			icon_living = "catgirl"
			icon_dead = "catgirl-dead"
			baseicon = "catgirl"
			awakeIcon = "catgirl"
			asleepIcon = "catgirlasleep"
		if(1)
			icon_state = "catgirlbrown"
			icon_living = "catgirlbrown"
			icon_dead = "catgirlbrown-dead"
			baseicon = "catgirlbrown"
			awakeIcon = "catgirlbrown"
			asleepIcon = "catgirlbrownasleep"
		if(2)
			icon_state = "catgirlred"
			icon_living = "catgirlred"
			icon_dead = "catgirlred-dead"
			baseicon = "catgirlred"
			awakeIcon = "catgirlred"
			asleepIcon = "catgirlredasleep"
		if(3)
			icon_state = "catgirlblack"
			icon_living = "catgirlblack"
			icon_dead = "catgirlblack-dead"
			baseicon = "catgirlblack"
			awakeIcon = "catgirlblack"
			asleepIcon = "catgirlblackasleep"
		else
			icon_state = "catgirl"
			icon_living = "catgirl"
			icon_dead = "catgirl-dead"
			baseicon = "catgirl"
			awakeIcon = "catgirl"
			asleepIcon = "catgirlasleep"
	return
